<?php
    /*
    Plugin Name: WooCommerce Live Sales Notifications
    Description: Show Real-time Sales Notifications to your website visitors with this creative marketing plugin. You can use a shortcode [live_sales_feed] to show the widget anywhere or turn the popup on in plugin settings (Woocommerce > Settings > Live Sales Notification).
    Author: AppZab
    Version: 3.1.1
    */

    defined('SB_DS') or define('SB_DS', DIRECTORY_SEPARATOR);
    require_once dirname(__FILE__) . SB_DS . 'plugin-functions.php';
    require_once dirname(__FILE__)  . SB_DS . 'zab-data-model.php';
    require_once dirname(__FILE__) . SB_DS . 'widget.php';
    /**
    * Check if WooCommerce is active
    **/
    function lsf_loader()
    {
        new RecentOrders();
        //if( class_exists( 'WooCommerce' ) )

    }    

    add_action('plugins_loaded', 'lsf_loader');

    function add_live_sales_feed_box()
    {
        add_meta_box("live-sales-feed-box", "Live Sales Notification", "custom_live_sales_feed", "post", "side", "high", null);
        add_meta_box("live-sales-feed-box", "Live Sales Notification", "custom_live_sales_feed", "page", "side", "high", null);
        add_meta_box("live-sales-feed-box", "Live Sales Notification", "custom_live_sales_feed", "product", "side", "high", null);

    }

    add_action("add_meta_boxes", "add_live_sales_feed_box");

    function custom_live_sales_feed($object)
    {
        wp_nonce_field(basename(__FILE__), "meta-box-nonce");

    ?>
    <div>


        <label for="meta-box-checkbox">Disable</label>
        <?php
            $checkbox_value = get_post_meta($object->ID, "live-sales-feed-disable", true);

            if($checkbox_value == "")
            {
            ?>
            <input name="live-sales-feed-disable" type="checkbox" value="true">
            <?php
            }
            else if($checkbox_value == "true")
            {
            ?>  
            <input name="live-sales-feed-disable" type="checkbox" value="true" checked>
            <?php
            }
        ?>
    </div>
    <?php  
    }

    function save_custom_live_sales_feed($post_id, $post, $update)
    {
        if (!isset($_POST["meta-box-nonce"]) || !wp_verify_nonce($_POST["meta-box-nonce"], basename(__FILE__)))
            return $post_id;

        if(!current_user_can("edit_post", $post_id))
            return $post_id;

        if(defined("DOING_AUTOSAVE") && DOING_AUTOSAVE)
            return $post_id;





        $meta_box_checkbox_value = "";


        if(isset($_POST["live-sales-feed-disable"]))
        {
            $meta_box_checkbox_value = $_POST["live-sales-feed-disable"];
        }   
        update_post_meta($post_id, "live-sales-feed-disable", $meta_box_checkbox_value);
    }

    add_action("save_post", "save_custom_live_sales_feed", 10, 3);

    add_action('widgets_init', 'register_recent_order_widget');
    function register_recent_order_widget()
    {
        register_widget( 'recentorderwidget' );
    }
    add_action('woocommerce_process_shop_order_meta', 'live_sales_feed_admin_checkout_option_save', 20, 2);
    function live_sales_feed_admin_checkout_option_save( $post_id, $post )
    {
        $option = $_POST['live_sales_feed_option'];
        if ($option == true) 
        { 
            update_post_meta( $post_id, 'show_order_option', 1);
        }
        else
        {
            update_post_meta( $post_id, 'show_order_option', 2);
        }
    }


    function customjs($hook) {

        wp_enqueue_script( 'customjs', plugin_dir_url( __FILE__ ) . '/js/custom.js' );
    }
    add_action( 'admin_enqueue_scripts', 'customjs' );
    function custom_admin_js() {
        if($_GET['tab']=='recent_order_widget'){   
            $number_of_click = get_option('number_of_click'); 
            $html .= '"<script type="text/javascript"> 
            var number_of_click ='. $number_of_click .';
			
            setInterval(function(){ 
            var data = {
            action: "live_sale_feed_count_click",
            my_var: "my_data"
            };

            jQuery.post( ajaxurl, data, function(response) {
            //alert(response);
            if(parseInt(number_of_click)<parseInt(response)) {
            jQuery("#number_of_click").val(response);
            jQuery("#number_of_click").text(response);

            }
            });
            }, 2000);
            </script>"';
                 $html1 ="";
             
                 $number_of_views = get_option('number_of_views'); 
            $html1 .= '"<script type="text/javascript"> 
            var number_of_views ='. $number_of_views .';
            setInterval(function(){ 
            var data = {
            action: "live_sale_feed_count_view",
            my_var: "my_data"
            };

            jQuery.post( ajaxurl, data, function(response) {
            //alert(response);
            if(parseInt(number_of_views)<parseInt(response)) {
            jQuery("#number_of_views").val(response);
            jQuery("#number_of_views").text(response);

            }
            });
            }, 2000);
            </script>"';
               
            echo       $html.  $html1;
        }
    }
 //   add_action('admin_footer', 'custom_admin_js');

    add_action( 'wp_ajax_live_sale_feed_count_click', 'live_sale_feed_count_click_callback' );     
    function live_sale_feed_count_click_callback() {
        // Do whatever you need with update_option() here.
        // You have full access to the $_POST object.

        $number_of_click = get_option('number_of_click'); 
        echo $number_of_click;
        wp_die();
}

 add_action( 'wp_ajax_live_sale_feed_count_view', 'live_sale_feed_count_view_callback' );     
    function live_sale_feed_count_view_callback() {
        // Do whatever you need with update_option() here.
        // You have full access to the $_POST object.

        $number_of_views = get_option('number_of_views'); 
        echo $number_of_views;
        wp_die();
}
add_filter('human_time_diff','thuman_time_diff',1,4);
function thuman_time_diff( $since, $diff, $from, $to){
    if ( $diff < HOUR_IN_SECONDS ) {
        $mins = round( $diff / MINUTE_IN_SECONDS );
        if ( $mins <= 1 ){
            return __('just now','appzab-woo-live-sales-feed');
        }else {
            return sprintf(__('about %s ago','appzab-woo-live-sales-feed'),$since);
        }
    }else  {
        return sprintf(__('about %s ago','appzab-woo-live-sales-feed'),$since);
    }
}

// Add to list of WC Order statuses
function add_dummy_order_to_order_statuses( $order_statuses ) {
    $new_order_statuses = array();
    foreach ( $order_statuses as $key => $status ) {
        $new_order_statuses[ $key ] = $status;
        if ( 'wc-processing' === $key ) {
            $new_order_statuses['wc-dummy-order'] = 'Inspiration Order';
        }
    }
    return $new_order_statuses;
}
add_filter( 'wc_order_statuses', 'add_dummy_order_to_order_statuses' );