<?php
   /*
   AppZab Live Sales Notification for WooCommerce      
   */
   
   ob_start();
   $cookie_name  = "number_of_time";
   $cookie_value = "";
   if (!isset($_COOKIE[$cookie_name])) {
       $cookie_value = 0;
       setcookie($cookie_name, $cookie_value, time() + (86400 * 30), "/"); // 86400 = 1 day
   }
   
   if (!class_exists("RecentOrders")):
       class RecentOrders
       {
           function __construct()
           {
               $this->init();
           }
           
           function init()
           {
               add_action('wp_enqueue_scripts', array(
                   $this,
                   'front_stylesheet'
               ));
               register_activation_hook(__FILE__, array(
                   $this,
                   'activate'
               ));
               add_filter('woocommerce_settings_tabs_array', array( $this,'add_setting_tab'),50);
               add_action('woocommerce_settings_recent_order_widget', array(
                   $this,
                   'show_tab'
               ));
               add_action('woocommerce_settings_tabs_recent_order_widget', array(
                   $this,
                   'show_options'
               ));
               add_action('woocommerce_update_options_recent_order_widget', array(
                   $this,
                   'save_options'
               ));
               add_action('woocommerce_checkout_after_customer_details', array(
                   $this,'live_sales_feed_checkout_option'
               ));
               add_action('woocommerce_checkout_update_order_meta', array(
                   $this,'live_sales_feed_update_order_meta'
               ));//DEV test
               add_action('woocommerce_admin_order_data_after_order_details', array(
                   $this,
                   'live_sales_feed_admin_checkout_option'
               ),60,2);
               add_shortcode('live_sales_feed', array($this,'recent_order'));
               add_action('wp_ajax_ajax_recent_order', array($this,'ajax_recent_order'));
               add_action('wp_ajax_nopriv_ajax_recent_order', array($this,'ajax_recent_order'));
               add_action('wp_footer', array($this,'action_wp_footer'));
               add_action('admin_enqueue_scripts', array($this,'admin_enqueue'));
               add_action('init', array($this,'setup_dummy_data_post'));
               add_action('wp_ajax_zab-load-products', array($this,'load_products'));
               add_action('wp_ajax_zab-add-sample-order', array($this,'add_sample_order'));
               add_action('wp_ajax_zab-fetch-edit-sample-order', array($this,'fetch_edit_sample_order'));
               add_action('wp_ajax_zab-delete-sample-order', array($this,'delete_sample_order'));
               add_action('wp_ajax_zab-get-product-form-options', array($this,'get_product_form_options'));
			   //add_action('save_post', 'zab_get_and_set_product_options' );
               add_filter('wc_order_statuses', array($this,'dummy_order_statuses'));
               add_action('pre_get_posts', array($this,'manipulate_order_query'));
               add_filter('wp_count_posts', array( $this,'manipulate_order_count'), 99, 3);
           }
           
           function front_stylesheet()
           {
               wp_enqueue_script('notification', plugins_url('/js/notification.js', __FILE__), array(
                   'jquery'
               ), '1.0');
               wp_register_style('front-style', plugins_url('/css/front.css', __FILE__));
               wp_register_style('animate', plugins_url('/css/animate.css', __FILE__));
               wp_enqueue_style('front-style');
               wp_enqueue_style('animate');
               wp_register_script('front-js', plugins_url('/js/car-jquery.js', __FILE__), array(
                   'jquery'
               ));
               wp_enqueue_script('front-js');
           }
           
           function activate()
           {
               add_option('woocommerce_no_of_order', '5', '', 'yes');
               add_option('display_customer_name', 'yes', '', 'yes');
               add_option('display_lfcity', 'yes', '', 'yes');
               add_option('display_product_name', 'yes', '', 'yes');
               add_option('display_product_image', 'yes', '', 'yes');
               add_option('display_time', 'yes', '', 'yes');
               add_option('selected_order_status', 'all', '', 'yes');
           }
           function add_setting_tab($data)
           {
               $data['recent_order_widget'] = __('Live Sales Notification', 'appzab-woo-live-sales-feed');
               return $data;
           }
           function get_setting_data()
           {
               global $woocommerce;
               $number_of_views = get_option('number_of_views');
               $number_of_views++;
               $order_statuses = array();
               if (version_compare($woocommerce->version, '2.2.0', '<')) {
                   $order_status_terms = get_terms('shop_order_status', array(
                       'hide_empty' => false
                   ));
                   if (!is_wp_error($order_status_terms)) {
                       // $order_status_terms = array();
                       foreach ($order_status_terms as $term) {
                           $order_statuses[$term->slug] = $term->name;
                       }
                   }
               } else {
                   $order_statuses = wc_get_order_statuses();
               }
               $woocommerce_settings = array(
                   array(
                       'title' => __('Live Sales Notification', 'appzab-woo-live-sales-feed'),
                       'type' => 'title',
                       'desc' => '',
                       'id' => 'recent_order_widget_option'
                   ),
                   array(
                       'title' => __("Enable Popup Notification", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'popup_notifier',
                       'default' => 'no',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
				   array(
                       'title' => __("Show Product Variations in Notifications", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'product_variations_popup_notifier',
                       'default' => 'no',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('No. Of Orders to Show', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'woocommerce_no_of_order',
                       'type' => 'number',
                       'css' => 'width:50px;',
                       'default' => '5',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('No. Of Orders to Show', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'woocommerce_no_of_order_widget',
                       'type' => 'number',
                       'css' => 'width:50px;',
                       'default' => '5',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Order status', 'appzab-woo-live-sales-feed'),
                       'id' => 'selected_order_status',
                       'class' => 'chosen_select',
                       'css' => 'width:400px;',
                       'type' => 'multiselect',
                       'default' => array(
                           'wc-dummy-order',
                           'wc-completed',
                           'wc-processing'
                       ),
                       'options' => $order_statuses,
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Order status', 'appzab-woo-live-sales-feed'),
                       'id' => 'selected_order_status_widget',
                       'class' => 'chosen_select',
                       'css' => 'width:400px;',
                       'type' => 'multiselect',
                       'default' => array(
                           'wc-dummy-order',
                           'wc-completed',
                           'wc-processing'
                       ),
                       'options' => $order_statuses,
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Display Product Image', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'display_product_image',
                       'default' => 'yes',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Product with highest value', 'appzab-woo-live-sales-feed'),
                       'id' => 'product_highest_value',
                       'type' => 'checkbox',
                       'desc' => __('Show product with highest value', 'appzab-woo-live-sales-feed'),
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Case Correction', 'appzab-woo-live-sales-feed'),
                       'id' => 'customer_text_case_popup',
                       'desc' => __('This applies to Customer First Name, Last Name and City', 'appzab-woo-live-sales-feed'),
                       'type' => 'select',
                       'options' => array(
                           'sentence' => 'Sentence Case',
                           'lower' => 'Lowercase',
                           'upper' => 'Uppercase',
                           'default' => 'No Change'
                       ),
                       'default' => 'default',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Case Correction', 'appzab-woo-live-sales-feed'),
                       'id' => 'customer_text_case_widget',
                       'desc' => __('This applies to Customer First Name, Last Name and City', 'appzab-woo-live-sales-feed'),
                       'type' => 'select',
                       'options' => array(
                           'sentence' => 'Sentence Case',
                           'lower' => 'Lowercase',
                           'upper' => 'Uppercase',
                           'default' => 'No Change'
                       ),
                       'default' => 'default',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => 'Product Title Link Color',
                       'desc' => __('Choose Color', 'appzab-woo-live-sales-feed'),
                       'id' => 'product_title_anchor_color',
                       'default' => '#000000',
                       'type' => 'color',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('First Line', 'appzab-woo-live-sales-feed'),
                       'desc' => __('Available tags: %firstname% %lastname% %lastnameinitial% %city% %state% %country% %ordertotal% %orderdate% %productname%', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_first_line',
                       'default' => '%productname%',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Font Size', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_first_line_font_size',
                       'placeholder' => '13px',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Choose Color', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_first_line_font_color',
                       'default' => '#000000',
                       'type' => 'color',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Second Line', 'appzab-woo-live-sales-feed'),
                       'desc' => __('Available tags: %firstname% %lastname% %lastnameinitial% %city% %state% %country% %ordertotal% %orderdate% %productname%', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_second_line',
                       'default' => __('Bought by %firstname% %lastname% from %city% %state%, %country%', 'appzab-woo-live-sales-feed'),
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Font Size', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_second_line_font_size',
                       'placeholder' => '13px',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Choose Color', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_second_line_font_color',
                       'default' => '#000000',
                       'type' => 'color',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Third Line', 'appzab-woo-live-sales-feed'),
                       'desc' => __('Available tags: %firstname% %lastname% %lastnameinitial% %city% %state% %country% %ordertotal% %orderdate% %productname%', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_third_line',
                       'default' => __('Total order for %ordertotal%', 'appzab-woo-live-sales-feed'),
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Font Size', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_third_line_font_size',
                       'placeholder' => '13px',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Choose Color', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_third_line_font_color',
                       'default' => '#000000',
                       'type' => 'color',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Fourth Line', 'appzab-woo-live-sales-feed'),
                       'desc' => __('Available tags: %firstname% %lastname% %lastnameinitial% %city% %state% %country% %ordertotal% %orderdate% %productname%', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_fourth_line',
                       'default' => '%orderdate%',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Font Size', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_fourth_line_font_size',
                       'placeholder' => '13px',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => '',
                       'desc' => __('Choose Color', 'appzab-woo-live-sales-feed'),
                       'id' => 'display_fourth_line_font_color',
                       'default' => '#000000',
                       'type' => 'color',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Display Customer First Name', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'display_first_name_widget',
                       'default' => 'true',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Display Customer Last Name', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'display_last_name_widget',
                       'default' => 'true',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Display Someone instead of name', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'display_someone_name_widget',
                       'default' => 'false',
                       'show_if_checked' => true,
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Display City', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'display_lfcity_widget',
                       'default' => 'yes',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Display Product Name', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'display_product_name_widget',
                       'default' => 'yes',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Display Product Image', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'display_product_image_widget',
                       'default' => 'yes',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Display Order totals', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'show_order_totals_widget',
                       'default' => 'true',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Scroll Interval', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'wc_feed_scroll_interval',
                       'default' => '2000',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Carousel items to see', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'wc_feed_scroll_items',
                       'default' => '3',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __('Carousel height', 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'wc_feed_scroll_height',
                       'default' => '375',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __("Direction", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'wc_feed_widget_direction',
                       'default' => 'up',
                       'type' => 'select',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       ),
                       'options' => array(
                           'up' => 'Up',
                           'right' => 'Right',
                           'left' => 'Left',
                           'down' => 'Down'
                       )
                   ),
                   array(
                       'title' => __("Order Sequence", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'wc_feed_ordertype',
                       'default' => 'rand',
                       'type' => 'select',
                       'options' => array(
                           'rand' => 'Select Randomly',
                           'DESC' => 'Latest Orders First',
                           'ASC' => 'Latest Orders Last'
                       ),
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Order Sequence", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'wc_feed_ordertype_widget',
                       'default' => 'rand',
                       'type' => 'select',
                       'options' => array(
                           'rand' => 'Select Randomly',
                           'DESC' => 'Latest Orders First',
                           'ASC' => 'Latest Orders Last'
                       ),
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   
                   array(
                       'title' => __("Time a popup stays on screen", 'appzab-woo-live-sales-feed'),
                       'desc' => __('How long each popup notification stays on the screen of your visitor (in milliseconds, eg.5000)', 'appzab-woo-live-sales-feed'),
                       'id' => 'deplay_time',
                       'default' => '5000',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Delay first notification", 'appzab-woo-live-sales-feed'),
                       'desc' => __('delay first notification for x seconds after the site is opened for first time.', 'appzab-woo-live-sales-feed'),
                       'id' => 'deplay_first_time',
                       'default' => '10000',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __('Delay between popups', 'appzab-woo-live-sales-feed'),
                       'desc' => 'Time in milliseconds between two popups',
                       'id' => 'wc_feed_delay_between_popups_appear',
                       'default' => '10000',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Limit Number of Popups in each session", 'appzab-woo-live-sales-feed'),
                       'desc' => "Show popup to a visitor only 'x' number of times in every session. 0 is infinite",
                       'id' => 'visitor_number_of_time',
                       'default' => '0',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Show purchased x time ago on widget?", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'show_bought_ago_lf_widget',
                       'default' => 'yes',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __("Popup Border Radius", 'appzab-woo-live-sales-feed'),
                       'desc' => 'If you want to add some style to your popups',
                       'id' => 'wc_feed_popup_border',
                       'default' => '0px',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Popup Opacity", 'appzab-woo-live-sales-feed'),
                       'desc' => 'Should be between 0 and 1',
                       'id' => 'popup_opacity',
                       'default' => '1',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   
                   array(
                       'title' => __("Disable on Mobile devices?", 'appzab-woo-live-sales-feed'),
                       'desc' => 'Popups are responsive but if you wish to disable them, simply check this option',
                       'id' => 'popup_notifier_mobile',
                       'default' => 'no',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Google Analytics UTM Parameter URL", 'appzab-woo-live-sales-feed'),
                       'desc' => 'eg. ?utm_source=livesalesfeed&utm_medium=popup&utm_campaign=marketing. This will append to the product URL in popup',
                       'id' => 'custom_html',
                       'default' => '?utm_source=livesalesfeed&utm_medium=popup&utm_campaign=marketing',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Google Analytics UTM Parameter URL", 'appzab-woo-live-sales-feed'),
                       'desc' => 'eg. ?utm_source=livesalesfeed&utm_medium=widget&utm_campaign=marketing. This will append to the product URL in popup',
                       'id' => 'custom_html_widget',
                       'default' => '?utm_source=livesalesfeed&utm_medium=widget&utm_campaign=marketing',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#widget'
                       )
                   ),
                   array(
                       'title' => __("Popup position on screen", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'location_show_popup',
                       'default' => 'leftbutton',
                       'type' => 'select',
                       'options' => array(
                           1 => 'top left',
                           2 => 'top right',
                           3 => 'bottom right',
                           4 => 'bottom left'
                       ),
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Animation Effect", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'show_popup_effect',
                       'default' => 'fadeOutDown',
                       'type' => 'select',
                       'options' => array(
                           'fadeIn' => 'fadeIn',
                           'zoomIn' => 'zoomIn',
                           'fadeOutDown' => 'fadeOutDown',
                           'bounceOutDown' => 'bounceOutDown',
                           'flipInY' => 'flipInY',
                           'zoomOut' => 'zoomOut',
                           'swing' => 'swing',
                           'flash' => 'flash'
                       ),
                       'custom_attributes' => array(
                           'data-tab' => '#popup'
                       )
                   ),
                   array(
                       'title' => __("Enable Customer's Permission on Checkout page?", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'id' => 'customer_permission_lf',
                       'default' => 'no',
                       'type' => 'checkbox',
                       'custom_attributes' => array(
                           'data-tab' => '#global'
                       )
                   ),
                   array(
                       'title' => __("Permission text for checkout page", 'appzab-woo-live-sales-feed'),
                       'desc' => '',
                       'css' => 'width:450px;',
                       'id' => 'wc_feed_checkout_text',
                       'default' => 'Include my information in Live Sales Notifications',
                       'type' => 'text',
                       'custom_attributes' => array(
                           'data-tab' => '#global'
                       )
                   ),
                   array(
                       'type' => 'sectionend',
                       'id' => 'recent_order_widget_option'
                   )
               );
               return $woocommerce_settings;
           }
           function show_tab()
           {
               $widget_url        = "'" . admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=widget') . "'";
               $popup_url         = "'" . admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=popup') . "'";
               $global_url        = "'" . admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=global') . "'";
               $sample_orders_url = "'" . admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=samples') . "'";
               echo '<ul id="livesale" class="subsubsub"><li><a href="#widget" onclick="jQuery(\'#samples_list\').removeClass(\'active\');return admin_setting.redirect(' . $widget_url . ');" >' . __('Widget Settings', 'appzab-woo-live-sales-feed') . '</a> | </li><li><a href="#popup" onclick="jQuery(\'#samples_list\').removeClass(\'active\');return admin_setting.redirect(' . $popup_url . ');" class="">' . __('Popup Settings', 'appzab-woo-live-sales-feed') . '</a> | </li><li><a href="#global"  onclick="jQuery(\'#samples_list\').removeClass(\'active\');return admin_setting.redirect(' . $global_url . ');" class="">' . __('Global Settings', 'appzab-woo-live-sales-feed') . '</a> | <a href="#samples" onclick="jQuery(\'#samples_list\').addClass(\'active\');return admin_setting.redirect(' . $sample_orders_url . ');">' . __('Inspirational (Fake) Orders', 'appzab-woo-live-sales-feed') . '</a>  </li></ul><br/>';
               if (isset($_GET['subtab']))
                   echo '<input type="hidden" name="_wp_current_tab"  value="' . $_GET['subtab'] . '" />';
           }
           function admin_enqueue($hook)
           {
               if ('woocommerce_page_wc-settings' != $hook) {
                   return;
               }
               wp_enqueue_script('admin-js', plugins_url('/js/adminjs.js', __FILE__));
               wp_enqueue_script('jquery-timepicker', plugins_url('/js/timepicker.jquery.js', __FILE__), array(
                   'jquery',
                   'jquery-ui-datepicker'
               ));
               wp_enqueue_style('admin-css', plugins_url('/css/back.css', __FILE__));
           }
           function show_options()
           {
               $data = $this->get_setting_data();
               woocommerce_admin_fields($data);
               $dummy_query = new WP_Query(array(
                   'post_type' => 'shop_order',
                   'post_status' => 'wc-dummy-order'
               ));
               
   ?>
<div id="samples_list" data-url="<?php
   echo admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=samples');
   ?>">
   <style scoped>
      #samples_list { display: none; }
      #samples_list.active { display: block; }
      table#samples_list_table td, table#samples_list_table th {
      border-top: 1px solid #000;
      border-right: 1px solid #000;
      padding: 14px;
      }
      table#samples_list_table td:first-child, table#samples_list_table th:first-child {
      border-left: 1px solid #000;
      }
      table#samples_list_table tr:last-child td {
      border-bottom: 1px solid #000;
      }
   </style>
    
    
 <h3>Add New Inspirational (Fake) Order</h3><br />
    <div style="border:1px solid #fdf9ec;padding:15px 10px;width:80%;background-color:#fdf9ec;">
        
        <p>
        Inspirational orders must have <strong><u>Inspiration</u></strong> set as the Order Status as shown below. <br /><br /><img src="../wp-content/plugins/appzab-woo-live-sales-notification/images/orderstatus.png" style="max-width:350px;border:1px solid #eee3be;"><br /><br />This order will be excluded from Woocommerce > Orders page and Woocommerce > Reports but will show in Live Sales Notifications. You can Edit or Delete these orders anytime from the section below. <br /><br />It is also possible to use external plugins to import multiple orders from a CSV file and set the order status to <em>Inspiration</em>. 
        </p>
        <br />
        <a class="button-primary" target="_blank" href="<?php echo admin_url('post-new.php?post_type=shop_order');?>"><?php
      _e('Add New Order', 'appzab-woo-live-sales-feed');
      ?></a>
      
      
    </div>
   <br />
   <h3>Manage Inspirational Orders</h3> <br />
    
    
   <?php
      if ($dummy_query->have_posts()):
      ?>
   <table id="samples_list_table" cellpadding="0" cellspacing="0">
      <tr>
         <th>Customer First Name</th>
         <th>Customer Last Name</th>
         <th>City</th>
         <th>State</th>
         <th>Country</th>
         <th>Products Selected</th>
         <th>Order Total</th>
         <th>Order Date/Time</th>
         <th>Actions</th>
      </tr>
      <?php
         while ($dummy_query->have_posts()):
             $dummy_query->the_post();
             $order = new WC_Order(get_the_ID());
             include plugin_dir_path(__FILE__) . 'includes/template-sample-order-tr.php';
         endwhile;
         ?>
   </table>
   <br />                        
   <?php
      wp_reset_postdata();
      endif;
      ?>
      
</div>
<?php
   }
   function save_options()
   {
       $data = $this->get_setting_data();
       woocommerce_update_options($data);
       $reset_click = get_option('reset_click');
       if ($reset_click == "yes") {
           update_option('number_of_click', 0);
           update_option('reset_click', "");
       }
       $reset_view = get_option('reset_view');
       if ($reset_view == "yes") {
           update_option('number_of_views', 0);
           update_option('reset_view', "");
       }
   }
   function recent_order()
   {
       $GLOBALS['active-dummy-order'] = true;
       $query_args = $this->buildQueryArgs('widget');
       // print_r($query_args);
       global $post;
       $postid         = $post->ID;
       $live_sale_feed = get_post_meta(get_the_ID(), 'live-sales-feed-disable', true);
       $query          = new WP_Query($query_args);
       $GLOBALS['active-dummy-order'] = false;
       if ($query->have_posts()) {
   ?>
<script type="text/javascript" language="javascript">
   jQuery(function () {
   
       var $c = jQuery('#carousel'),
   
           $w = jQuery(window);
   
       $c.carouFredSel({
   
           items: <?php
      print get_option('wc_feed_scroll_items');
      ?>,
   
           height: <?php
      print get_option('wc_feed_scroll_height');
      ?>,
   
           direction: "<?php
      print get_option('wc_feed_widget_direction');
      ?>",
   
           scroll: {
   
               items: 1,
   
               duration: <?php
      print get_option('wc_feed_scroll_interval');
      ?>,
   
               pauseOnHover: 'immediate',
   
               timeoutDuration: 2000
   
           },
   
       });
   
   });
   
   var ajaxurl = "<?php
      echo admin_url('admin-ajax.php');
      ?>";
   
   
   // setInterval('abc()', 25000);
   
   
   function abc() {
   
       jQuery.ajax({
   
           type: 'POST',
   
           url: ajaxurl,
   
           dataType: 'json',
   
           data: {'action': 'ajax_recent_order'},
   
           success: function (data) {
   
   
   
               // alert(data.result);
   
               // jQuery('#carousel').empty();
   
   
               jQuery('#carousel').html(data.result);
   
   
               // jQuery("ul#carousel > li:lt(5)").remove();
   
   
           }
   
   
       });
   
   }
   
</script>
<div style="clear:all;">
   <ul class="prdct-list" id="carousel">
      <?php
         while ($query->have_posts()):
             $query->the_post();
             global $product, $post;
             if ('0000-00-00 00:00:00' == $post->post_date) {
                 $t_time = $h_time = __('Unpublished', 'appzab-woo-live-sales-feed');
             } else {
                 $t_time    = get_the_time(__('d/m/Y g:i:s A', 'appzab-woo-live-sales-feed'), $post);
                 $gmt_time  = strtotime($post->post_date_gmt);
                 $time_diff = current_time('timestamp', 1) - $gmt_time;
                 if ($time_diff > 0 && $time_diff < 24 * 60 * 60)
                     $h_time = sprintf(__('%s ago', 'woocommerce'), human_time_diff($gmt_time, current_time('timestamp', 1)));
                 else
                     $h_time = get_the_time(__('d/m/Y', 'appzab-woo-live-sales-feed'), $post);
             }
             $order = new WC_Order(get_the_ID());
             if (sizeof($order->get_items()) > 0):
                 $item     = current($order->get_items());
                 $_product = $order->get_product_from_item($item);
                 if (!is_object($_product))
                     continue;
         ?>
      <li>
         <div class="prdct-img">
            <?php
               if (get_option('display_product_image_widget') == 'yes') {
               ?>
            <div class="div-left">
               <a class="pr-img" href="<?php
                  echo esc_url(get_permalink($item['product_id']));
                  ?>"> <?php
                  echo $_product->get_image('shop_thumbnail', array(
                      'title' => ''
                  ));
                  ?> </a>
            </div>
            <?php
               }
               ?>
            <div class="div-right">
               <?php
                $custom_html = get_option('custom_html_widget');
                if( $_product->get_type() == 'variation' ) {
                    if ( $custom_html ) {
                        if ( substr( $custom_html, 0, 1 ) == '?' ) {
                            $custom_html = '&' . substr( $custom_html, 1 );
                        }
                    }
                }

                  if (get_option('display_product_name_widget') == 'yes') {
                  ?>                  
               <a class="pr-tit" href="<?php
                  echo esc_url(get_permalink($_product->get_id()) . $custom_html );
                  ?>"> <?php
                  echo esc_attr( zab_get( $_product, 'product_name' ) );
                  ?> </a>
               <?php
                  $pl   = ($order->get_item_count() - 1) > 1 ? ' Items' : ' Item';
                  $more = ($order->get_item_count() > 1) ? '&nbsp;+&nbsp;' . ($order->get_item_count() - 1) . $pl : '<br />';
                  echo "<span class='more'>" . $more . "</span>";
                  ?>
               <?php
                  }
                  ?>
               <div>
                  <span class="label-two"> <?php
                     $lfbought = __('Bought by', 'appzab-woo-live-sales-feed');
                     ?>
                  <?php
                     printf(__('%s'), $lfbought);
                     ?>
                  <?php
                     $case = get_option('customer_text_case_widget');
                     if ($case == 'default') {
                         $first_name = zab_get( $order, 'billing_first_name' );
                         $last_name  = zab_get( $order, 'billing_last_name' );
                         $city       = zab_get( $order, 'billing_city' );
                         $someone = __('someone', 'appzab-woo-live-sales-feed');
                     } else if ($case == 'sentence') {
                         $first_name = ucfirst(strtolower(zab_get( $order, 'billing_first_name' ) ) );
                         $last_name  = ucfirst(strtolower(zab_get( $order, 'billing_last_name' ) ) );
                         $city       = ucfirst(strtolower(zab_get( $order, 'billing_city' ) ) );
                         $someone = ucfirst(strtolower( __('someone', 'appzab-woo-live-sales-feed') ));
                     } else if ($case == 'upper') {
                         $first_name = strtoupper(zab_get( $order, 'billing_first_name' ) );
                         $last_name  = strtoupper(zab_get( $order, 'billing_last_name' ) );
                         $city       = strtoupper(zab_get( $order, 'billing_city' ) );
                         $someone = strtoupper( __('someone', 'appzab-woo-live-sales-feed') );
                     } else if ($case == 'lower') {
                         $first_name = strtolower(zab_get( $order, 'billing_first_name' ) );
                         $last_name  = strtolower(zab_get( $order, 'billing_last_name' ) );
                         $city       = strtolower(zab_get( $order, 'billing_city' ) );
                         $someone = strtolower( __('someone', 'appzab-woo-live-sales-feed') );
                     }
                     if (get_option('display_someone_name_widget') == 'yes'):
                         print ' ' . $someone . ' ';
                     else:
                         if (get_option('display_first_name_widget') == 'yes'):
                     ?>
                  <?php
                     echo esc_html($first_name) . ' ';
                     ?>
                  <?php
                     endif;
                     ?>
                  <?php
                     if (get_option('display_last_name_widget') == 'yes'):
                     ?>
                  <?php
                     echo esc_html($last_name);
                     ?>
                  <?php
                     endif;
                     endif;
                     ?>
                  <?php
                     if (get_option('display_lfcity_widget') == 'yes') {
                     ?>
                  from <?php
                     echo esc_html($city);
                     ?>
                  <?php
                     }
                     ?>
                  </span>
               </div>
               <?php
                  if (get_option('show_order_totals_widget') == 'yes'):
                  ?>
               <?php
                  printf("Total order for %s<br/>", $order->get_formatted_order_total());
                  ?>
               <?php
                  endif;
                  ?>
               <?php
                  if (get_option('show_bought_ago_lf_widget') == 'yes') {
                  ?>
               <span class="ticker-time"> <?php
                  echo esc_attr($h_time);
                  ?></span>
               <?php
                  }
                  ?>
            </div>
         </div>
      </li>
      <?php
         endif;
         endwhile;
         ?>
   </ul>
</div>
<?php
   }
   wp_reset_postdata();
   }
   function ajax_recent_order()
   {
   global $post;
   $postid         = $post->ID;
   $live_sale_feed = get_post_meta(get_the_ID(), 'live-sales-feed-disable', true);
   $GLOBALS['active-dummy-order'] = true;
   $query_args     = $this->buildQueryArgs('popup');
   $query          = new WP_Query($query_args);
   $GLOBALS['active-dummy-order'] = false;
   if ($live_sale_feed != "true") {
       if ($query->have_posts()) {
           while ($query->have_posts()):
               $query->the_post();
               global $product, $post;
               if ('0000-00-00 00:00:00' == $post->post_date) {
                   $t_time = $h_time = __('Unpublished', 'appzab-woo-live-sales-feed');
               } else {
                   $t_time    = get_the_time(__('d/m/Y g:i:s A', 'appzab-woo-live-sales-feed'), $post);
                   $gmt_time  = strtotime($post->post_date_gmt);
                   $time_diff = current_time('timestamp', 1) - $gmt_time;
                   if ($time_diff > 0 && $time_diff < 24 * 60 * 60)
                       $h_time = human_time_diff($gmt_time, current_time('timestamp', 1));
                   $h_time = get_the_time(__('d/m/Y', 'appzab-woo-live-sales-feed'), $post);
               }
               $order = new WC_Order(get_the_ID());
               if (sizeof($order->get_items()) > 0):
                   $item     = current($order->get_items());
                   $_product = $order->get_product_from_item($item);
                   $out .= '<li><div class="prdct-img">';
                   if (get_option('display_product_image') == 'yes') {
                       $out .= '<div class="div-left"><a class="pr-img" href="' . esc_url(get_permalink($item['product_id'])) . '">' . $_product->get_image('shop_thumbnail', array(
                           'title' => ''
                       )) . '</a></div>';
                   }
                   $out .= '<div class="div-right">';
                   if (get_option('display_product_name') == 'yes') {
                       $out .= '<a class="pr-tit" href="' . esc_url(get_permalink($item['product_id'])) . '">' . esc_attr($_product->get_title()) . '</a>';
                       $pl   = ($order->get_item_count() - 1) > 1 ? ' Items' : ' Item';
                       $more = ($order->get_item_count() > 1) ? '&nbsp;+&nbsp;' . ($order->get_item_count() - 1) . $pl : '<br />';
                       $out .= "<span class='more'>" . $more . "</span>";
                   }
                   $out .= '<div><span class="label-two">';
                   if (get_option('display_customer_name') == 'yes') {
                       $out .= 'Bought by ' . esc_html($order->billing_first_name) . ' ' . esc_html($order->billing_last_name);
                   }
                   if (get_option('display_lfcity') == 'yes') {
                       $out .= '&nbsp;from ' . esc_html($order->billing_city);
                   }
                   $out .= '</span></div>';
                   if (get_option('display_time') == 'yes') {
                       $out .= '<span class="ticker-time">' . esc_attr($h_time) . '</span>';
                   }
                   $out .= '</div></div></li>';
               endif;
           endwhile;
       }
       wp_reset_postdata();
       echo json_encode(array(
           'result' => $out
       ));
       die();
   }
   }
   function live_sales_feed_checkout_option()
   {
   global $woocommerce;
   if (get_option('customer_permission_lf', 'no') != 'yes')
       echo '<style type="text/css"> #live_sales_feed_option_field{ display: none; } </style>';
   /*return false;*/
   $lfinclude = get_option('wc_feed_checkout_text');
   echo '<div id="my-new-field">';
   woocommerce_form_field('live_sales_feed_option', array(
       'type' => 'checkbox',
       'class' => array(
           'input-checkbox'
       ),
       'label' => $lfinclude
   ), 1);
   echo '</div><br/>';
   }
   function live_sales_feed_update_order_meta($order_id)
   {
   if ($_POST['live_sales_feed_option']) {
       update_post_meta($order_id, 'show_order_option', esc_attr($_POST['live_sales_feed_option']));
   } else {
       update_post_meta($order_id, 'show_order_option', 2);
   }
   }
   function live_sales_feed_admin_checkout_option($order)
   {
	if(isset($_GET["post"]) && $_GET["post"] > 0)
	{
   		$option = get_post_meta($_GET["post"], 'show_order_option', true);
	}
	else
	{
		$option = "";
	}
   $val    = empty($option) ? null : $option;
   if ($val == 1 || !($val)) {
       $chk = "checked=checked";
   }
   echo '<p class="form-field form-field-wide">
   
       <input type="checkbox" ' . $chk . ' id="live_sales_feed_option" name="live_sales_feed_option" style="width:0%">Include information in the Live Sales Notification.
   
       </p>';
   }
   protected function buildQueryArgs($type)
   {
   $query_type = '';
   if ($type == 'widget') {
       $query_type = '_widget';
   }
   $c          = count(get_option('selected_order_status' . $query_type));
   $today      = getdate(strtotime("+1 day"));
   $query_args = array(
       'post_type' => 'shop_order',
       'posts_per_page' => ($type == 'widget') ? get_option('woocommerce_no_of_order_widget') : get_option('woocommerce_no_of_order'),
       'orderby' => 'ID',
       'order' => ($type == 'widget') ? get_option('wc_feed_ordertype_widget') : get_option('wc_feed_ordertype'),
       'date_query' => array(
           array(
               'before' => array(
                   'year' => $today['year'],
                   'month' => $today['mon'],
                   'day' => $today['mday']
               )
           )
       )
   );
   if ($type == 'widget') {
       $type = '_widget';
   } else {
       $type = '';
   }
   if (get_option('wc_feed_ordertype' . $type) == 'rand') {
       $query_args['orderby'] = ($type == 'widget') ? get_option('wc_feed_ordertype_widget') : get_option('wc_feed_ordertype');
   }
   if (get_option('selected_order_status' . $query_type) == 'all' || $c == 0) {
       if (version_compare(WC()->version, '2.2.0', '<')) {
           // print "woocommerce <= 2.1.0";
           $query_args['post_status'] = 'publish';
           $query_args['meta_query']  = array(
               'relation' => 'OR',
               array(
                   'key' => 'show_order_option',
                   'compare' => 'NOT EXISTS',
                   'value' => ''
               ),
               array(
                   'key' => 'show_order_option',
                   'value' => 1
               )
           );
       }
      
   } else {
	   if ( function_exists( 'WC' ) ) {
			if (version_compare(WC()->version, '2.2.0', '<')) {
				// print "woocommerce <= 2.1.0";
				$query_args['post_status'] = 'publish';
				$query_args['meta_query']  = array(
					'relation' => 'OR',
					array(
						'key' => 'show_order_option',
						'compare' => 'NOT EXISTS',
						'value' => ''
					),
					array(
						'key' => 'show_order_option',
						'value' => 1
					)
				);
				$tax_query                 = array(
					'taxonomy' => 'shop_order_status',
					'field' => 'slug',
					'terms' => get_option('selected_order_status' . $query_type),
					'operator' => 'IN'
				);
				$query_args['tax_query']   = array(
					$tax_query
				);
			} else {
				$statuses                  = get_option('selected_order_status' . $query_type);
				$statuses[]                = 'wc-dummy-order';
				// print "woocommerce > 2.1.0";
				$query_args['post_status'] = $statuses;
				$query_args['meta_query']  = array(
					'relation' => 'OR',
					array(
						'key' => 'show_order_option',
						'compare' => 'NOT EXISTS',
						'value' => ''
					),
					array(
						'key' => 'show_order_option',
						'value' => 1
					)
				);
			}
		} else {
			global $woocommerce;
			if ( is_object( $woocommerce ) && property_exists( $woocommerce, 'version' ) ) {

				if (version_compare( $woocommerce->version, '2.2.0', '<')) {
					// print "woocommerce <= 2.1.0";
					$query_args['post_status'] = 'publish';
					$query_args['meta_query']  = array(
						'relation' => 'OR',
						array(
							'key' => 'show_order_option',
							'compare' => 'NOT EXISTS',
							'value' => ''
						),
						array(
							'key' => 'show_order_option',
							'value' => 1
						)
					);
					$tax_query                 = array(
						'taxonomy' => 'shop_order_status',
						'field' => 'slug',
						'terms' => get_option('selected_order_status' . $query_type),
						'operator' => 'IN'
					);
					$query_args['tax_query']   = array(
						$tax_query
					);
				} else {
					$statuses                  = get_option('selected_order_status' . $query_type);
					$statuses[]                = 'wc-dummy-order';
					// print "woocommerce > 2.1.0";
					$query_args['post_status'] = $statuses;
					$query_args['meta_query']  = array(
						'relation' => 'OR',
						array(
							'key' => 'show_order_option',
							'compare' => 'NOT EXISTS',
							'value' => ''
						),
						array(
							'key' => 'show_order_option',
							'value' => 1
						)
					);
				}
			}
		}
   }
   // print_r($query_args);
   return $query_args;
   }
   
   public function parse_line_tags($order, $product, $item, $string)
   {
   $case = get_option('customer_text_case_popup');
   if ($case == 'default') {
       $first_name = zab_get( $order, 'billing_first_name' );
       $last_name  = zab_get( $order, 'billing_last_name' );
	   $state       = strtolower(zab_get( $order, 'billing_state' ) );
       $city       = zab_get( $order, 'billing_city' );
	   $last_name_ini  = zab_get( $order, 'billing_last_name' );
   } else if ($case == 'sentence') {
      $first_name = ucfirst(strtolower(zab_get( $order, 'billing_first_name' ) ) );
      $last_name  = ucfirst(strtolower(zab_get( $order, 'billing_last_name' ) ) );
	  $state       = strtolower(zab_get( $order, 'billing_state' ) );
      $city       = ucfirst(strtolower(zab_get( $order, 'billing_city' ) ) );
	  $last_name_ini  = zab_get( $order, 'billing_last_name' );
   } else if ($case == 'upper') {
       $first_name = strtoupper(zab_get( $order, 'billing_first_name' ) );
       $last_name  = strtoupper(zab_get( $order, 'billing_last_name' ) );
       $state       = strtolower(zab_get( $order, 'billing_state' ) );
	   $city       = strtoupper(zab_get( $order, 'billing_city' ) );
	   $last_name_ini  = zab_get( $order, 'billing_last_name' );
   } else if ($case == 'lower') {
       $first_name = strtolower(zab_get( $order, 'billing_first_name' ) );
       $last_name  = strtolower(zab_get( $order, 'billing_last_name' ) );
       $state       = strtolower(zab_get( $order, 'billing_state' ) );
	   $city       = strtolower(zab_get( $order, 'billing_city' ) );
	   $last_name_ini  = zab_get( $order, 'billing_last_name' );
   }
   
   $order_date = human_time_diff( strtotime( zab_get( $order, 'date' ) ) );
   
   $pl   = ($order->get_item_count() - 1) > 1 ? ' Items' : ' Item';
   $more = ($order->get_item_count() > 1) ? '&nbsp;+&nbsp;' . ($order->get_item_count() - 1) . $pl : '<br />';
   
   $custom_html = get_option('custom_html');
    if( $product->get_type() == 'variation' ) {
        if ( $custom_html ) {
            if ( substr( $custom_html, 0, 1 ) == '?' ) {
                $custom_html = '&' . substr( $custom_html, 1 );
            }
        }
    }
	if( $product->get_type() == 'variation' )
	{
		$product_variations_popup_notifier = get_option('product_variations_popup_notifier');
		if( $product_variations_popup_notifier == "yes" )
		{
			$product_string = sprintf('<a href="%s%s" style="color:%s">%s</a>%s', get_permalink($product->get_id()), $custom_html, get_option('product_title_anchor_color'), zab_get( $product, 'product_name' ), $more);
		}
		else
		{
			$temp_product_title =  $product->get_parent_data();
			$product_string = sprintf('<a href="%s%s" style="color:%s">%s</a>%s', get_permalink($product->get_id()), $custom_html, get_option('product_title_anchor_color'), $temp_product_title["title"], $more);
		}
	}
	else
	{
		$product_string = sprintf('<a href="%s%s" style="color:%s">%s</a>%s', get_permalink($product->get_id()), $custom_html, get_option('product_title_anchor_color'), zab_get( $product, 'product_name' ), $more);
	}
   if ($country_code = zab_get( $order, 'billing_country' ) )
       $country = WC()->countries->countries[substr($country_code, 0, 2)];
   else
       $country = '';
	   
	$countries_obj = new WC_Countries();
	$countries_array = $countries_obj->get_countries();
	$country_states_array = $countries_obj->get_states();
	
	// Get the country name:
	$country_name = $countries_array[$country_code];
	// Get the state name:
	$state_name = $country_states_array[$country_code][strtoupper($state)];
	  
   $string = str_replace('%productname%', $product_string, $string);
   $string = str_replace('%firstname%', $first_name, $string);
   $string = str_replace('%lastname%', $last_name, $string);
   $string = str_replace('%lastnameinitial%', $last_name_ini[0], $string);
   $string = str_replace('%state%', $state_name, $string);
   $string = str_replace('%city%', $city, $string);
   $string = str_replace('%country%', $country, $string);
   $string = str_replace('%ordertotal%', $order->get_formatted_order_total(), $string);
   $string = str_replace('%orderdate%', $order_date, $string);
   
   return $string;
   }
   
   public function setup_dummy_data_post()
   {
	   if (class_exists('WC_Order')) {
		   //$add_flag = false;
		   //if (is_admin() && isset($_GET['post_type']) && $_GET['post_type'] == 'shop_order') {
			   // do nothing                        
		   //} else
			   $add_flag = true;
		   
			   if ($add_flag) {
				   register_post_status('wc-dummy-order', array(
					   'label' => __('Inspiration', 'appzab-woo-live-sales-feed'),
					   'public' => true,
					   'exclude_from_search' => true,
					   'show_in_admin_all_list' => false,
					   'show_in_admin_status_list' => false,
					   'label_count'  => _n_noop( 'Inspiration Order <span class="count">(%s)</span>', 'Inspiration Order <span class="count">(%s)</span>' )
				   ));
			   }
	   }
   }
   
   public function load_products()
   {
   $total    = 0;
   $products = $_POST['products'];
   if (!$products)
       echo $total;
   else {
       foreach ($products as $product_id) {
           $product = wc_get_product($product_id);
           $total += $product->get_price();
       }
       echo $total;
   }
   exit;
   }
   
   public function add_sample_order()
   {
   if (!isset($_POST['sample-nonce-field']) || !wp_verify_nonce($_POST['sample-nonce-field'], 'zab-edit-order'))
       return;
   extract($_POST);
   
   if ($orderId) {

        $order = new WC_Order($orderId);

   } else {

        if ( !is_zab_legacy() ) {

            $order = new WC_Order();

        } else {

            add_filter( 'woocommerce_default_order_status', function() {
                return 'dummy-order';
            }, 90, 0 );

            $order = wc_create_order();

        }
   }
   

    zab_set( $order, 'billing_first_name', $firstName );
    zab_set( $order, 'billing_last_name', $lastName);
    zab_set( $order, 'billing_city', $city);
    zab_set( $order, 'billing_country', $country);
   
   $total = $orderTotal;
   if ($customOrderTotal)
       $total = $customOrderTotal;
   
   $order->set_total($total);
   
   zab_set( $order, 'status', 'wc-dummy-order' );
   
   if (!empty($products)) {
       $order->remove_order_items();
       foreach ($products as $product_id) {
           $order->add_product(wc_get_product($product_id), 1);
       }
   }
   
    if ( !is_zab_legacy() ) $order->save();
   
   zab_set( $order, 'date', $orderDate );
   
   $wp_date_format = date("Y-m-d H:i:s", strtotime($orderDate));
   $result         = wp_update_post(array(
       'ID' => zab_get( $order, 'id' ),
       'post_date' => $wp_date_format,
       'post_date_gmt' => get_gmt_from_date($wp_date_format)
   ));
   
   include plugin_dir_path(__FILE__) . 'includes/template-sample-order-tr.php';
   exit;
   }
   
   public function fetch_edit_sample_order()
   {
   $order = new WC_Order($_POST['id']);
   
   $items          = $order->get_items();
   $products_array = array();
   if (!empty($items)) {
       foreach ($items as $item) {
           $product = $order->get_product_from_item($item);
           array_push($products_array, $product->get_id());
       }
   }
   echo json_encode(array(
       'firstName' => zab_get( $order, 'billing_first_name' ),
       'lastName' => zab_get( $order, 'billing_last_name' ),
       'city' => zab_get( $order, 'billing_city' ),
       'country' => zab_get( $order, 'billing_country' ),
       'products' => $products_array,
       'total' => $order->get_total(),
       'date' => date('F j, Y H:i', strtotime( zab_get( $order, 'date') ) ),
       'id' => zab_get( $order, 'id' )
   ));
   exit;
   }
   
   public function delete_sample_order()
   {
   if (isset($_POST['id'])) {
       $id = $_POST['id'];
       
       $order = wp_delete_post($id);
       if ($order)
           $success = true;
       else
           $success = false;
       
       echo json_encode(array(
           'success' => $success,
           'id' => $id
       ));
       exit;
   }
   }
   
   public function dummy_order_statuses($order_statuses)
   {
   if (isset($_POST['action']) && $_POST['action'] == 'zab-add-sample-order') {
       $new_order_statuses = array();
       // add new order status after processing
       foreach ($order_statuses as $key => $status) {
           $new_order_statuses[$key] = $status;
           if ('wc-processing' === $key) {
               $new_order_statuses['wc-dummy-order'] = __('Inspiration Order', 'appzab-woo-live-sales-feed');
           }
       }
       return $new_order_statuses;
   } else
       return $order_statuses;
   }

   public function get_product_form_options() {
		$options = zab_get_product_form_options();
		if ( !empty( $options ) ) {
			foreach( $options as $id => $product ) { ?>
				<option value="<?php echo $id; ?>"><?php echo $product; ?></option>
			<?php }
		}
		exit;
	}
   
   public function manipulate_order_count($counts, $type, $perm)
   {
   if ($type == 'shop_order') {
       $counts->{'wc-dummy-order'} = 0;
   }
   return $counts;
   }
   
   public function manipulate_order_query($wp_query)
   {
        if ( isset( $wp_query->query[ 'post_type' ] ) ) {

            if ( $wp_query->query[ 'post_type' ] == 'shop_order') {

                if ( isset( $wp_query->query[ 'post_status' ] ) ) {

                    $post_statuses = $wp_query->query[ 'post_status' ];
                    if ( empty( $post_statuses ) || !is_array( $post_statuses ) ) return;
                    if ( count($post_statuses == 1 ) && $post_statuses[0] == 'wc_dummy_order') return;

                    $counter = 0;
                    foreach ($post_statuses as $status) {
                        if ( $status == 'wc-dummy-order' ) {
                            if ( isset( $GLOBALS['active-dummy-order'] ) ) {
                                if ( !$GLOBALS['active-dummy-order'] )
                                    unset($post_statuses[$counter]);
                            } else unset($post_statuses[$counter]);
                        }
                        $counter++;
                    }

                    $wp_query->set('post_status', $post_statuses);
                }
            }
        }
   }
   
   public function action_wp_footer()
   {
   global $post;
   $postid         = $post->ID;
   $live_sale_feed = get_post_meta(get_the_ID(), 'live-sales-feed-disable', true);
   if ($live_sale_feed != "true") {
       $number_of_views = get_option('number_of_views');
       $number_of_views++;
       // update_option( 'number_of_views', $number_of_views);
       $cookie_name = "number_of_time";
       if ((get_option('visitor_number_of_time') > $_COOKIE[$cookie_name]) || (get_option('visitor_number_of_time') == 0)) {
           if (!isset($_COOKIE["live_sale_notify_last_view"])) {
			   $cookie_value = -1;
			   setcookie("live_sale_notify_last_view", $cookie_value, time() + (86400 * 30), "/");
			   $live_sale_notify_last_view_cookie_value = -1;
		   }
		   else
		   {
			   setcookie("live_sale_notify_last_view", (intval($_COOKIE["live_sale_notify_last_view"]) + 1), time() + (86400 * 30), "/");
			   $live_sale_notify_last_view_cookie_value = (intval($_COOKIE["live_sale_notify_last_view"]) + 1);
		   }
		   $cookie_value = intval($_COOKIE[$cookie_name]) + 1;
           setcookie($cookie_name, $cookie_value, time() + (86400 * 30), "/"); // 86400 = 1 day
           if ($live_sale_feed != "true") {
               global $woocommerce;
               if (get_option('popup_notifier', 'no') != 'yes')
                   return false;
               if (isset($_COOKIE['wc_feed_closed']))
                   return false;
               $GLOBALS['active-dummy-order'] = true;
               $args  = $this->buildQueryArgs('popup');
               
			   $query = new WP_Query($args);
			   
               $GLOBALS['active-dummy-order'] = false;
               if (!$query->have_posts())
                   return false;
               $opacity = (float) get_option('popup_opacity');
               $pborder = get_option('wc_feed_popup_border');
   ?>
<style>
   .live-sale-notify {
   border-radius: <?php
      print $pborder;
      ?>px;
   opacity: <?php
      print $opacity;
      ?>;
   }
   <?php
      if (get_option('popup_notifier_mobile') == 'yes'):
      ?>
   @media screen and (max-width: 480px) {
   .live-sale-notify {
   display: none;
   }
   }                    
   <?php
      endif;
      $showtime            = get_option('deplay_time');
      $popup_effect        = get_option('show_popup_effect');
      $location_show_popup = get_option('location_show_popup');
      $showfirsttime       = get_option('deplay_first_time');
      $number_of_time      = get_option('visitor_number_of_time');
      ?>
</style>
<script>
   var interval = null;
   
   var current_index = <?php echo $live_sale_notify_last_view_cookie_value ?>;
   
   var sales_feeds = [];
   var admin_ajax_url = "<?php echo admin_url( 'admin-ajax.php' ) ?>";
   var showtime = <?php
      echo ($showtime) ? $showtime : 0;
      ?>;
   var showfirsttime = <?php
      echo ($showfirsttime) ?: 0;
      ?>;
   
   var number_of_time = <?php
      echo $number_of_time;
      ?>;
   
   var visible_times = 0;
   
   <?php
      $s = get_option('wc_feed_delay_between_popups_appear');
      if (!$s) {
          $s = 1000;
      }
      ?>
   function hide_prev_feed_notify(index) {
   
       if (sales_feeds.eq(current_index).length > 0) {
   
           sales_feeds.eq(current_index).animate({bottom: '-90px'}, 500);
   
       }
   
   }
   
   function show_live_feed_notify(index,showtime) {
    var content = sales_feeds.eq(index).html();
   
   Notification.create(content,'<?php
      echo $popup_effect;
      ?>',<?php
      echo $location_show_popup;
      ?>,showtime/1000);
   
       //sales_feeds.eq(index).animate({bottom: '10px'}, 1000);
   
   
       current_index = index;
   
   }
   
   function show_next_live_notify() {   
       visible_times++;
       if ((current_index + 1) >= sales_feeds.length) {
           current_index = -1;
       }
	   document.cookie = "live_sale_notify_last_view="+current_index+"; path=/";
       if (window.console)   
           console.log('will show ' + (current_index + 1));   
       if (visible_times <= number_of_time || number_of_time == 0  )
		{
		   show_live_feed_notify(current_index + 1,showtime);
       }
       else {
           var data = {   
               action: 'live_sale_feed_view',   
               number_of_time: number_of_time   
           };
           jQuery.post(ajaxurl, data, function (response) {
           });
           jQuery('.wc_feed_close_btn').trigger('click');
       }   
   }
   
   function stop_live_notify() {
   
       removeInterval(inverval);
   
   }
   
   function readCookie(name) {
   
       var nameEQ = escape(name) + "=";
   
       var ca = document.cookie.split(';');
   
       for (var i = 0; i < ca.length; i++) {
   
           var c = ca[i];
   
           while (c.charAt(0) === ' ') c = c.substring(1, c.length);
   
           if (c.indexOf(nameEQ) === 0) return unescape(c.substring(nameEQ.length, c.length));
   
       }
   
       return null;
   
   }
   
   jQuery(function () {
   
       jQuery('body').on('click touchstart','.wc_feed_close_btn',function () {
           var days = 30;
   
           var date = new Date();
   
           date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
   
   
               console.log(date.toGMTString());
   
           document.cookie = 'wc_feed_closed=true; expires=' + date.toGMTString() + ';';
   
           jQuery('.live-sale-notify').css('display', 'none');
   
           clearInterval(interval);
   
           return false;
   
       });
   
   
       sales_feeds = jQuery('.live-sale-notify');
   
       setTimeout(function () {
           show_next_live_notify();
           interval = setInterval(show_next_live_notify, (showtime + <?php
      print $s + 100;
      ?>));
       }, showfirsttime);
   });
   
</script>
<?php
   $countries = WC()->countries->countries; //;WC()->countries->get_countries();
   while ($query->have_posts()) {
       $query->the_post();
       global $post;
       $order = new WC_Order(get_the_ID());
       $items = $order->get_items();

       if (count($order->get_items()) <= 0)
           continue;
       
	   
			
       $expensive = 0;
       $flag      = null;
       
       $highest_value = get_option('product_highest_value');
       
       if ($highest_value == 'yes') {
           foreach ($items as $key => $item_data) {
               $data = zab_get( $item_data, 'item_data' );
               $total     = $data['total'];
               if ($total > $expensive) {
                   $flag      = $key;
                   $expensive = $total;
               }
           }
       } else {
           foreach ($items as $key => $item_data) {
               $flag = $key;
               break;
           }
       }
	   
       $_product = $order->get_product_from_item($items[$flag]);   
	   
       if (!is_object($_product))
           continue;
       $img          = $_product->get_image('shop_thumbnail', array(
           'title' => ''
       ));
       //$time_elapsed = time_elapsed_string('@' . strtotime($order->order_date));
       $gmt_time     = strtotime($post->post_date_gmt);
       $time_diff    = current_time('timestamp', 1) - $gmt_time;
       /*if ($time_diff > 0 && $time_diff < 24 * 60 * 60) {
       $time_elapsed = sprintf(__('%s ago', 'woocommerce') , human_time_diff($gmt_time, current_time('timestamp', 1)));
       } else {
       $time_elapsed = get_the_time(__('d/m/Y', 'woocommerce') , $post);
       }*/
       $time_elapsed = human_time_diff($gmt_time, current_time('timestamp', 1));
   ?>
<?php
   $lfbought = get_option('wc_feed_boughtby_text');
   ?>
<div class="live-sale-notify">
   <div class="illustration"> <?php
      if (get_option('display_product_image') == 'yes') {
      ?><?php
      echo '<input type="hidden" value="1" id="display_product_image">';
      $custom_html = get_option('custom_html');
      if( $_product->get_type() == 'variation' ) {
          if ( $custom_html ) {
              if ( substr( $custom_html, 0, 1 ) == '?' ) {
                  $custom_html = '&' . substr( $custom_html, 1 );
              }
          }
      }
      printf('<a href="%s">%s</a>', get_permalink($_product->get_id()) . $custom_html, $img);
      ?>
      <?php
         } else {
             echo '&nbsp;';
             echo '<input type="hidden" value="0" id="display_product_image">';
         }
         ?>
   </div>
   <?php
      if ($line = get_option('display_first_line')):
      ?> 
   <?php
      $style = '';
      if ($line_color = get_option('display_first_line_font_color'))
          $style .= 'color:' . $line_color . ';';
      if ($line_size = get_option('display_first_line_font_size'))
          $style .= 'font-size:' . $line_size . ';';
      ?>
   <div class="text" style="<?php
      echo $style;
      ?>">
      <?php
         echo $this->parse_line_tags($order, $_product, $items[$flag], $line);
         ?>
   </div>
   <?php
      endif;
      ?>
   <?php
      if ($line = get_option('display_second_line')):
      ?> 
   <?php
      $style = '';
      if ($line_color = get_option('display_second_line_font_color'))
          $style .= 'color:' . $line_color . ';';
      if ($line_size = get_option('display_second_line_font_size'))
          $style .= 'font-size:' . $line_size . ';';
      ?>
   <div class="text" style="<?php
      echo $style;
      ?>">
      <?php
         echo $this->parse_line_tags($order, $_product, $items[$flag], $line);
         ?>
   </div>
   <?php
      endif;
      ?>
   <?php
      if ($line = get_option('display_third_line')):
      ?> 
   <?php
      $style = '';
      if ($line_color = get_option('display_third_line_font_color'))
          $style .= 'color:' . $line_color . ';';
      if ($line_size = get_option('display_third_line_font_size'))
          $style .= 'font-size:' . $line_size . ';';
      ?>
   <div class="text" style="<?php
      echo $style;
      ?>">
      <?php
         echo $this->parse_line_tags($order, $_product, $items[$flag], $line);
         ?>
   </div>
   <?php
      endif;
      ?>
   <?php
      if ($line = get_option('display_fourth_line')):
      ?> 
   <?php
      $style = '';
      if ($line_color = get_option('display_fourth_line_font_color'))
          $style .= 'color:' . $line_color . ';';
      if ($line_size = get_option('display_fourth_line_font_size'))
          $style .= 'font-size:' . $line_size . ';';
      ?>
   <div class="text" style="<?php
      echo $style;
      ?>">
      <?php
         echo $this->parse_line_tags($order, $_product, $items[$flag], $line);
         ?>
   </div>
   <?php
      endif;
      ?>
   <div class="dismiss wc_feed_close_btn">&nbsp;</div>
</div>
<?php
}
}
}
}
}
}
endif;
function time_elapsed_string($datetime, $full = false)
{
$now     = new DateTime;
$ago     = new DateTime($datetime);
$diff    = $now->diff($ago);
$diff->w = floor($diff->d / 7);
$diff->d -= $diff->w * 7;
$string = array(
'y' => 'year',
'm' => 'month',
'w' => 'week',
'd' => 'day',
'h' => 'hour',
'i' => 'minute',
's' => 'second'
);
foreach ($string as $k => &$v) {
if ($diff->$k) {
$v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
} else {
unset($string[$k]);
}
}
if (!$full)
$string = array_slice($string, 0, 1);
return $string ? implode(', ', $string) . ' ago' : 'just now';
}
add_action('wp_ajax_live_sale_feed_click', 'live_sale_feed_click_callback');
function live_sale_feed_click_callback()
{
// Do whatever you need with update_option() here.
// You have full access to the $_POST object.
$number_of_click = get_option('number_of_click');
$number_of_click++;
update_option('number_of_click', $number_of_click);
die();
}
add_action('wp_ajax_live_sale_feed_view', 'live_sale_feed_view_callback');
function live_sale_feed_view_callback()
{
// Do whatever you need with update_option() here.
// You have full access to the $_POST object.
$number_of_views = get_option('number_of_views');
$number_of_views++;
update_option('number_of_views', $number_of_views);
$cookie_name  = "number_of_time";
$cookie_value = intval($_POST['number_of_time']) + 1;
setcookie($cookie_name, $cookie_value, time() + (86400 * 30), "/"); // 86400 = 1 day
die();
}

function zab_get_product_form_options()
{
	$options_transient = get_transient( 'zab_product_form_options' );

	if ( $options_transient === false ) {		
		$options_transient = zab_get_and_set_product_options();
	}
	return $options_transient;
}

function zab_get_and_set_product_options() {
	$products = get_posts( array(
		'posts_per_page' => -1,
		'post_type' => array(
			'product',
			'product_variation'
		),
    'fields' => 'ids'
	));

	$product_array = array();
	if (!empty($products)) {
		
		foreach ($products as $product) {			
			$product                           = wc_get_product($product);
      $title                             = $product->post->post_title;
			$product_array[$product->get_id()] = ($product->get_type() == 'variation') ? ' - ' . $title : $title;
		}
	}

	set_transient( 'zab_product_form_options', $product_array, MINUTE_IN_SECONDS ); // DAY_IN_SECONDS
	return $product_array;
}

function is_zab_legacy( $version = "3.0" ) {
    if ( class_exists( 'WooCommerce' ) ) {        
		global $woocommerce;
		if ( version_compare( $woocommerce->version, $version, "<" ) ) {
			return true;
		}
	}
	return false;
}