<?php

function zab_get( $obj, $method ) {

    $default_methods = array(
        'billing_first_name', 'billing_last_name',
        'billing_city', 'billing_state', 'billing_country', 'id'
    );

    if ( !is_zab_legacy() ) :
        // WC3+

        if ( in_array( $method, $default_methods ) ) :
            
            // Follows default get_$method format            

            // Setup method_variable
            $method = 'get_' . $method;
            return $obj->{ $method }();

        else :

            if ( $method == 'date' ) return $obj->get_date_created();
            if ( $method == 'product_name' ) return $obj->get_name();
            if ( $method == 'item_data' ) return $obj->get_data();

        endif;

    else :
        // < WC3

        if ( in_array( $method, $default_methods ) ) :
            return $obj->{ $method };

        else :

            if ( $method == 'date' ) return $obj->order_date;
            if ( $method == 'product_name' ) {
                if ( $obj->get_type() != 'variation' ) {
                    return $obj->post->post_title;
                } else {
                    return get_the_title( $obj->variation_id );
                }
            }

            if ( $method == 'item_data' ) return array( 'total' => $obj[ 'item_meta' ][ '_line_total' ] );

        endif;

    endif;
}

function zab_set( $obj, $method, $value ) {

    $default_methods = array(
        'billing_first_name', 'billing_last_name',
        'billing_city','billing_state', 'billing_country'
    );

    if ( !is_zab_legacy() ) :
        // WC3+

        if ( in_array( $method, $default_methods ) ) :

            // Follows default get_$method format     

            // Setup method_variable
            $method = 'set_' . $method;
            $obj->{ $method }( $value );

        else :

            if ( $method == 'status' ) $obj->set_status( $value, '', true);
            if ( $method == 'date' ) $obj->set_date_created( strtotime( $value ) );

        endif;

    else :
        // < WC3

        if ( in_array( $method, $default_methods ) ) :

            update_post_meta( $obj->id, "_" . $method, $value );

        else :

            if ( $method == 'status' ) $obj->post_status = $value;
            if ( $method == 'date' ) $obj->order_date = $value;



        endif;
    endif;
}